<script>
    import Spinner from 'components/Icons/Spinner.svelte'
    import Avatar from 'components/User/Avatar.svelte'
    import Name from 'components/User/Name.svelte'
    import Username from 'components/User/Username.svelte'
    import Header from 'components/Header.svelte'
    import { get } from 'lib/fetch'
    import { validateSelf } from 'lib/validate'
    import { getRelationStatus } from 'lib/relations'
    import { awaitingAPI } from 'store'

    let q
    let users = []

    const search = async () => {
        const errors = await validateSelf(['min:2'], q)
        if (errors.length > 0) return

        const { req, res } = await get('api/user/search', { q })
        if (req.ok) {
            users = res.data
        }
    }
</script>

<Header>
    <input
        placeholder="Rechercher sur FooSocial"
        type="text"
        bind:value={q}
        on:input={search}
        slot="override"
    />
</Header>

<section>
    {#if !$awaitingAPI || users.length > 0}
        {#each users as user (user.username)}
            <a href="@{user.username}">
                <div class="user">
                    <div class="infos">
                        <Avatar name={user.name} src={user.avatar} />
                        <div>
                            <Name>{user.name}</Name>
                            <Username>@{user.username}</Username>
                        </div>
                    </div>
                    <p class="relation">
                        {#await getRelationStatus(user.username)}
                            <Spinner size="small" />
                        {:then status}
                            {#if status === 'friend'}Ami{/if}
                        {/await}
                    </p>
                </div>
            </a>
        {:else}
            <div class="no-content">
                Effectue une recherche pour trouver des utilisateurs
            </div>
        {/each}
    {:else}
        <div class="no-content">
            <Spinner />
        </div>
    {/if}
</section>

<style lang="postcss">
    input {
        @apply w-full px-3 py-2 rounded-xl bg-blueGray-200 appearance-none;

        &::placeholder {
            @apply text-blueGray-900;
        }

        &:focus {
            @apply outline-none ring-1 ring-teal-500 border-teal-500;
        }
    }

    section {
        @apply flex flex-col bg-blueGray-50 pt-4;

        a {
            @apply bg-white border-t;
            &:last-of-type {
                @apply border-b;
            }

            .user {
                @apply relative flex items-center justify-between gap-x-2 p-4;

                .infos {
                    @apply flex flex-initial gap-x-2 min-w-0;

                    div {
                        @apply min-w-0;
                    }

                    :global(h2) {
                        @apply block;
                    }
                }

                .relation {
                    @apply text-blueGray-700 italic text-right;
                }
            }
        }

        .no-content {
            @apply flex-1 flex items-center justify-center text-center text-blueGray-500;
        }
    }
</style>
